<?php
namespace Bushelpowered\Api\Aggregator\Quoting\V1;

use \Bushelpowered\Api\Aggregator\Quoting\V1\Request\UpdateQuoteRequest;
use \Bushelpowered\Api\Aggregator\Quoting\V1\Response\StaffUpdateQuoteResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class StaffUpdateQuote 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(UpdateQuoteRequest $request, $headers): StaffUpdateQuoteResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/aggregator/quoting/v1/StaffUpdateQuote', $request, $this->getWrapper(), $headers);
    }
    
    public function request(UpdateQuoteRequest $request, StaffUpdateQuoteMetadata $hasHeaders): StaffUpdateQuoteResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/aggregator/quoting/v1/StaffUpdateQuote', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var StaffUpdateQuoteResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.aggregator.quoting.v1#StaffUpdateQuoteSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Aggregator\Quoting\V1\Response\StaffUpdateQuoteResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}